# TCG Emulation

Details about QEMU’s Tiny Code Generator and the infrastructure associated with emulation. You do not need to worry about this if you are only implementing things for HW accelerated hypervisors.

- Translator Internals
  - CPU state optimisations
  - Direct block chaining
  - Self-modifying code and translated code invalidation
  - Exception support
  - MMU emulation
- Decodetree Specification
  - Fields
  - Argument Sets
  - Formats
  - Patterns
  - Pattern Groups
- Multi-threaded TCG
  - vCPU Scheduling
  - Shared Data Structures
  - Memory Consistency
- TCG Instruction Counting
  - Core Concepts
- QEMU TCG Plugins
  - Usage
  - Writing plugins
  - Internals
  - Example Plugins
  - API
- Execution Record/Replay
  - Core concepts
  - Virtual devices
  - Replay log format